﻿#include "MQPlugin.h"
#include "MQBasePlugin.h"

class PolygonCounter : public MQStationPlugin
{
public:
	friend PolygonCounterWindow;

	PolygonCounter();
	virtual ~PolygonCounter();

	// プラグインIDを返す。
	virtual void GetPlugInID(DWORD *Product, DWORD *ID);
	// プラグイン名を返す。
	virtual const char *GetPlugInName(void);
	// ポップアップメニューに表示される文字列を返す。
	virtual const char *EnumString(void);

	// アプリケーションの初期化
	virtual BOOL Initialize();
	// アプリケーションの終了
	virtual void Exit();

	// 表示・非表示切り替え要求
	virtual BOOL Activate(MQDocument doc, BOOL flag);
	// 表示・非表示状態の返答
	virtual BOOL IsActivated(MQDocument doc);

	virtual void OnObjectModified(MQDocument doc);
	virtual void OnUpdateObjectList(MQDocument doc);
	virtual BOOL OnUndo(MQDocument doc, int undo_state);
	virtual BOOL OnRedo(MQDocument doc, int redo_state);
	virtual void OnNewDocument(MQDocument doc, const char *filename, NEW_DOCUMENT_PARAM& param);

	typedef bool (PolygonCounter::*ExecuteCallbackProc)(MQDocument doc);

	void Execute(ExecuteCallbackProc proc);

protected:
	struct CallbackInfo {
		ExecuteCallbackProc proc;
	};

	// コールバックに対する実装部
	virtual bool ExecuteCallback(MQDocument doc, void *option);

private:
	PolygonCounterWindow *m_Window;

	void count(MQDocument doc);
	void countobj(cmq::CMQObject obj, int &countv, int &countf, int &count2, int &count3, int &count4, int &count5);

	bool m_bActivate;
	bool m_bUpdate; // リアルタイム更新
	bool m_bAll; // 全オブジェクト
	bool m_bVisible; // 可視オブジェクトのみ
	bool m_bFreeze; // 鏡面、曲面、回転体をフリーズしてカウントする
	bool m_bTriangle; // 四角形以上は三角形換算してカウントする
	bool m_bPolygon; // ポリゴン毎の表示欄の可視
};

