#include <windows.h>

#include <string>
#include <sstream>

#include "PolygonCounterWindow.h"
#include "PolygonCounter.h"

PolygonCounterWindow::PolygonCounterWindow(PolygonCounter *plugin, MQWindowBase& parent) : MQWindow(parent), m_pPlugin(plugin)
{
	SetTitle(L"PolygonCounter");

	this->SetHorzLayout(LAYOUT_AUTO);
	this->SetVertLayout(LAYOUT_AUTO);

	MQFrame *frame2 = CreateHorizontalFrame(this);
	frame2->SetMultiColumn(true);
	frame2->SetMatrixColumn(2);

	m_checkUpdate = CreateCheckBox(frame2, L"Update");
	m_checkUpdate->AddChangedEvent(this, &PolygonCounterWindow::checkUpdate);
	m_checkUpdate->SetChecked(m_pPlugin->m_bUpdate);

	m_checkAll = CreateCheckBox(frame2, L"All");
	m_checkAll ->AddChangedEvent(this, &PolygonCounterWindow::checkAll);
	m_checkAll->SetChecked(m_pPlugin->m_bAll);

	m_checkVisible = CreateCheckBox(frame2, L"Visible");
	m_checkVisible->AddChangedEvent(this, &PolygonCounterWindow::checkVisible);
	m_checkVisible->SetChecked(m_pPlugin->m_bVisible);

	m_checkFreeze = CreateCheckBox(frame2, L"Freeze");
	m_checkFreeze->AddChangedEvent(this, &PolygonCounterWindow::checkFreeze);
	m_checkFreeze->SetChecked(m_pPlugin->m_bFreeze);

	m_checkTriangle = CreateCheckBox(frame2, L"Triangle");
	m_checkTriangle->AddChangedEvent(this, &PolygonCounterWindow::checkTriangle);
	m_checkTriangle->SetChecked(m_pPlugin->m_bTriangle);

	m_checkPolygon = CreateCheckBox(frame2, L"Polygon");
	m_checkPolygon->AddChangedEvent(this, &PolygonCounterWindow::checkPolygon);
	m_checkPolygon->SetChecked(m_pPlugin->m_bPolygon);

	MQFrame *frame1 = CreateVerticalFrame(this);
	{
		MQGroupBox *groupc = CreateGroupBox(frame1, L"current");

		MQFrame *framec1 = CreateHorizontalFrame(groupc);
		framec1->SetMultiColumn(true);
		framec1->SetMatrixColumn(2);

		MQLabel *m_labelv = CreateLabel(framec1, L"V");
		m_editv = CreateEdit(framec1);
		m_editv->SetReadOnly(true);
		m_editv->SetAlignment(MQEdit::ALIGN_RIGHT);

		MQLabel *m_labelf = CreateLabel(framec1, L"F");
		m_editf = CreateEdit(framec1);
		m_editf->SetReadOnly(true);
		m_editf->SetAlignment(MQEdit::ALIGN_RIGHT);

		framec2 = CreateHorizontalFrame(groupc);
		framec2->SetMultiColumn(true);
		framec2->SetMatrixColumn(2);
		framec2->SetVisible(m_pPlugin->m_bPolygon);

		MQLabel *m_label2 = CreateLabel(framec2, L"2");
		m_edit2 = CreateEdit(framec2);
		m_edit2->SetReadOnly(true);
		m_edit2->SetAlignment(MQEdit::ALIGN_RIGHT);

		MQLabel *m_label3 = CreateLabel(framec2, L"3");
		m_edit3 = CreateEdit(framec2);
		m_edit3->SetReadOnly(true);
		m_edit3->SetAlignment(MQEdit::ALIGN_RIGHT);

		MQLabel *m_label4 = CreateLabel(framec2, L"4");
		m_edit4 = CreateEdit(framec2);
		m_edit4->SetReadOnly(true);
		m_edit4->SetAlignment(MQEdit::ALIGN_RIGHT);

		MQLabel *m_label5 = CreateLabel(framec2, L"5");
		m_edit5 = CreateEdit(framec2);
		m_edit5->SetReadOnly(true);
		m_edit5->SetAlignment(MQEdit::ALIGN_RIGHT);
	}
	{
		groupa = CreateGroupBox(frame1, L"all");
		groupa->SetCanMinimize(true);
		groupa->SetMinimized(!m_pPlugin->m_bAll);
		groupa->AddResizeEvent(this, &PolygonCounterWindow::resize);

		MQFrame *framea1 = CreateHorizontalFrame(groupa);
		framea1->SetMultiColumn(true);
		framea1->SetMatrixColumn(2);

		MQLabel *m_labelva = CreateLabel(framea1, L"V");
		m_editva = CreateEdit(framea1);
		m_editva->SetReadOnly(true);
		m_editva->SetAlignment(MQEdit::ALIGN_RIGHT);

		MQLabel *m_labelfa = CreateLabel(framea1, L"F");
		m_editfa = CreateEdit(framea1);
		m_editfa->SetReadOnly(true);
		m_editfa->SetAlignment(MQEdit::ALIGN_RIGHT);

		framea2 = CreateHorizontalFrame(groupa);
		framea2->SetMultiColumn(true);
		framea2->SetMatrixColumn(2);
		framea2->SetVisible(m_pPlugin->m_bPolygon);

		MQLabel *m_label2a = CreateLabel(framea2, L"2");
		m_edit2a = CreateEdit(framea2);
		m_edit2a->SetReadOnly(true);
		m_edit2a->SetAlignment(MQEdit::ALIGN_RIGHT);

		MQLabel *m_label3a = CreateLabel(framea2, L"3");
		m_edit3a = CreateEdit(framea2);
		m_edit3a->SetReadOnly(true);
		m_edit3a->SetAlignment(MQEdit::ALIGN_RIGHT);

		MQLabel *m_label4a = CreateLabel(framea2, L"4");
		m_edit4a = CreateEdit(framea2);
		m_edit4a->SetReadOnly(true);
		m_edit4a->SetAlignment(MQEdit::ALIGN_RIGHT);

		MQLabel *m_label5a = CreateLabel(framea2, L"5");
		m_edit5a = CreateEdit(framea2);
		m_edit5a->SetReadOnly(true);
		m_edit5a->SetAlignment(MQEdit::ALIGN_RIGHT);
	}

	AddHideEvent(this, &PolygonCounterWindow::OnHide);
}

PolygonCounterWindow::~PolygonCounterWindow()
{
}

BOOL PolygonCounterWindow::OnHide(MQWidgetBase *sender, MQDocument doc)
{
	if(m_pPlugin->m_bActivate){
		m_pPlugin->m_bActivate = false;
		m_pPlugin->WindowClose();
	}
	return FALSE;
}

BOOL PolygonCounterWindow::resize(MQWidgetBase *sender, MQDocument doc)
{
	// all GroupBox̐܂݃Cxg
	// `FbN{bNXɔf
	if(groupa->GetMinimized() == m_checkAll->GetChecked()) {
		m_checkAll->SetChecked(!m_checkAll->GetChecked());
		checkAll(sender, doc);
	}
	POINT windowsize = this->GetJustSize();
	this->SetHeight(windowsize.y);
	return FALSE;
}

BOOL PolygonCounterWindow::checkAll(MQWidgetBase *sender, MQDocument doc)
{
	if(groupa->GetMinimized() == m_checkAll->GetChecked()) {
		groupa->SetMinimized(!m_checkAll->GetChecked());
	}
	m_pPlugin->m_bAll = m_checkAll->GetChecked();
	m_pPlugin->count(doc);
	return FALSE;
}

BOOL PolygonCounterWindow::checkUpdate(MQWidgetBase *sender, MQDocument doc)
{
	m_pPlugin->m_bUpdate = m_checkUpdate->GetChecked();
	m_pPlugin->count(doc);
	return FALSE;
}

BOOL PolygonCounterWindow::checkVisible(MQWidgetBase *sender, MQDocument doc)
{
	m_pPlugin->m_bVisible = m_checkVisible->GetChecked();
	m_pPlugin->count(doc);
	return FALSE;
}

BOOL PolygonCounterWindow::checkFreeze(MQWidgetBase *sender, MQDocument doc)
{
	m_pPlugin->m_bFreeze = m_checkFreeze->GetChecked();
	m_pPlugin->count(doc);
	return FALSE;
}

BOOL PolygonCounterWindow::checkTriangle(MQWidgetBase *sender, MQDocument doc)
{
	m_pPlugin->m_bTriangle = m_checkTriangle->GetChecked();
	m_pPlugin->count(doc);
	return FALSE;
}

BOOL PolygonCounterWindow::checkPolygon(MQWidgetBase *sender, MQDocument doc)
{
	m_pPlugin->m_bPolygon = m_checkPolygon->GetChecked();
	// |S\̃t[؂ւ
	framec2->SetVisible(m_checkPolygon->GetChecked());
	framea2->SetVisible(m_checkPolygon->GetChecked());
	POINT windowsize = this->GetJustSize();
	this->SetHeight(windowsize.y);
	return FALSE;
}

std::wstring itostr(int n)
{
	std::wostringstream os;
	os << n;
	return os.str();
}

void PolygonCounterWindow::setcurrent(int countv, int countf, int count2, int count3, int count4, int count5)
{
	m_editv->SetText(itostr(countv));
	m_editf->SetText(itostr(countf));
	m_edit2->SetText(itostr(count2));
	m_edit3->SetText(itostr(count3));
	m_edit4->SetText(itostr(count4));
	m_edit5->SetText(itostr(count5));
}

void PolygonCounterWindow::setall(int countv, int countf, int count2, int count3, int count4, int count5)
{
	m_editva->SetText(itostr(countv));
	m_editfa->SetText(itostr(countf));
	m_edit2a->SetText(itostr(count2));
	m_edit3a->SetText(itostr(count3));
	m_edit4a->SetText(itostr(count4));
	m_edit5a->SetText(itostr(count5));
}
